/*
	Public domain, by Zig Zichterman.
*/
/*
	LGBClipRgn
	
	Storage for the clip region.  Use this class to save and
	restore the clip region across draws
	
	avoid destructor tricks to avoid requiring C++ runtime stuff.
	
	11/27/94	zz	h	initial write
*/
#pragma once

class LGBClipRegion
{
	public :
		LGBClipRegion(void);
		
		void
		Save(void);
		
		void
		Restore(void) const;
	
		void
		Dispose(void);
		
		Boolean
		HasClip(void) const;
		
		RgnHandle	mClipRgn;
};
