/**************************************************************************
	LGBControl
	
	Public domain, by Zig Zichterman.
	
	Just a few utilities that the control classes use.
	
	Some of the drawing code is taken from the public domain source
	accompanying _develop_ 15.

	1.0b5
		11/27/94	zz	h	add CalcBackgroundColor()
**************************************************************************/
#pragma once

class LGBControl {

	//  Draw Utilities 
	public :
		static short
		CountLines(
			const StringPtr inString);
			
		static short
		TitleHeight(
			const StringPtr inTitle);
			
		static void
		SetupFont(void)
			{
				::TextFont(systemFont);
				::TextSize(0);
			}
			
		static void
		CalcBoxes(
			const Rect		&inControlRect,
			const StringPtr	inTitle,
			Rect			&outCheckbox,
			Rect			&outTitleRect);

		static void
		CalcBackgroundColor(
			const ControlHandle	inControl,
			const WindowPtr		inWindow,
			RGBColor			&outColor);
};
