/*
	Public domain, by Zig Zichterman.
*/
/*
	LGBFont
	
	A container for the current font, size, mode and face
	
	avoid destructor tricks because we want to
	avoid requiring C++ runtime stuff
	
	11/27/94	zz	h	initial write
*/
#include "LGBFont.h"

/**************************************************************************
	LGBFont()										[public]
	
	Create a blank font record.  Save the current font
	info into it
**************************************************************************/
LGBFont::LGBFont(void)
{
	mFont	=
	mSize	=
	mMode	=
	mFace	= 0;
	
	Save();
}

/**************************************************************************
	Save()											[public]
	
	Save the current port's font info
**************************************************************************/
void
LGBFont::Save(void)
{
	GrafPtr	currentPort	= NULL;
	::GetPort(&currentPort);
	if (currentPort) {
		mFont	= currentPort->txFont;
		mSize	= currentPort->txSize;
		mMode	= currentPort->txMode;
		mFace	= currentPort->txFace;
	}
}

/**************************************************************************
	Restore()										[public]
	
	Restore the current port's font info to whatever we
	last saved. You get truly bogus results if you never
	saved before
**************************************************************************/
void
LGBFont::Restore(void)
{
	::TextFont(mFont);
	::TextSize(mSize);
	::TextMode(mMode);
	::TextFace(mFace);
}
