/*
	Copyright  1994 Zig Zichterman. All rights reserved.
*/
/*
	LGBPen
	
	Storage for pen info--foreground and background colors
	
	avoid destructor tricks because we want to
	avoid requiring C++ runtime stuff
	
	11/27/94	zz	h	initial write
*/
#include "LGBPen.h"

#include <Palettes.h>

/**************************************************************************
	LGBPen(void)										[public]
	
	Create a blank pen.  Use Save() to save the current pen info
**************************************************************************/
LGBPen::LGBPen(void)
{
	Save();
}

/**************************************************************************
	Save()												[public]
	
	Save the current pen's info for a later Restore().
**************************************************************************/
void
LGBPen::Save(void)
{
	::SaveFore(&mForeColor);
	::SaveBack(&mBackColor);
	::GetPenState(&mPenState);
}

/**************************************************************************
	Restore()											[public]
	
	Set the pen to the most recently Save()d info
**************************************************************************/
void
LGBPen::Restore(void)
{
	::RestoreFore(&mForeColor);
	::RestoreBack(&mBackColor);
	::SetPenState(&mPenState);
}

/**************************************************************************
	Normal()											[public, static]
	
	Force all settings under our control to something sensible
**************************************************************************/
void
LGBPen::Normal(void)
{
	::ForeColor(blackColor);
	::BackColor(whiteColor);
	::PenNormal();
}

