/**************************************************************************
	LGBPushButton
	
	Public domain, by Zig Zichterman.
	
	This class implements 3D push buttons according to the guidelines
	suggested in _develop_ 15. Some of the drawing code is taken from
	the public domain source accompanying _develop_ 15.
	
	11/25/94	zz	add CreateMask()
**************************************************************************/
#pragma once

class LGBPushButton {
	public :
		static long
		Main(
			short			inVariation,
			ControlHandle	ioControl,
			short			inMsg,
			long			ioParam);

	protected :
		ControlHandle	mControl;
		Boolean			mUseWFont;
		GrafPtr			mWindowPort;
		RGBColor		mBackgroundColor;
		RGBColor		mInactiveFrameColor;

	//  constructor 
		LGBPushButton(
			ControlHandle	inControl,
			Boolean			inUseWFont);
			
		
	//  dispatch 
	protected :
		void
		Draw(
			long	inPartCode);
			
		Boolean
		Test(
			Point	inHitPt);
			
		void
		CalcCRgn(
			RgnHandle	ioRgn);
		
	//  Draw 
	protected :
		void
		DrawBW(void);
		
		void
		DrawColor(void);
		
		void
		DrawColorInactive(void);
		
		void
		DrawColorActive(void);
		
		void
		DrawName(
			Boolean	inDim1Bit = false);
		
		void
		DrawFrame(void);
		
		RgnHandle
		CreateMask(void);
		
		void
		EraseInsides(void);
		
		void
		Draw3DEffects(void);

		void
		CalcColors(void);
		
		void
		UseBackgroundColor(void);
				
		void
		UseInactiveFrameColor(void);
};

