/**************************************************************************
	LGBRadio
	
	Public domain, by Zig Zichterman.
	
	This class implements 3D radio buttons according to the guidelines
	suggested in _develop_ 15. Some of the drawing code is taken from
	the public domain source accompanying _develop_ 15.

	1.0b5
		12/06/94	zz	more color stuff--inactive frame/text color
		11/27/94	zz	add Calc/UseBackgroundColor(), mBackgroundColor
						make mControl a ControlHandle (was ControlRecord*)
**************************************************************************/
#pragma once

class LGBRadio {
	public :
		static long
		Main(
			short			inVariation,
			ControlHandle	ioControl,
			short			inMsg,
			long			ioParam);

	//  contstructor 
	protected :
		LGBRadio(
			ControlHandle	inControl,
			Boolean			inUseWFont);

		ControlHandle	mControl;
		Boolean			mUseWFont;
		WindowPtr		mWindowPort;
		RGBColor		mBackgroundColor;
		RGBColor		mInactiveFrameColor;
		
	//  dispatch 
	protected :
		void
		Draw(
			long	inPartCode);
			
		Boolean
		Test(
			Point	inHitPt);
			
		void
		CalcCRgn(
			RgnHandle	ioRgn);
		
	//  Draw 
	protected :
		void
		DrawBW(void);
		
		void
		DrawColor(void);
		
		void
		DrawColorActive(void);
		
		void
		DrawColorInactive(void);
		
		void
		CalcBoxes(
			Rect	&outRadiobox,
			Rect	&titleBox);
			
		void
		DrawRadio(
			const Rect	&inRadiobox);
			
		void
		DrawTitle(
			const Rect	&inTitlebox,
			Boolean		inDim1Bit	= false);
			
		void
		DrawRadioColor(
			const Rect	&inRadiobox);
		
		void
		CalcColors(void);
		
		void
		UseBackgroundColor(void);
		
		void
		UseInactiveFrameColor(void);
};

