//----------------------------------------------------------------------------------------
//	File:		MDemo3D.cp
//
//	Contains:	3D drawing demo program
//
//	Written by:	Jamie Osborne
// 				Adapted for 3.1.1 by Jeroen Schalk
//
//	Copyright:	 1992-1994 by Apple Computer, Inc.
//----------------------------------------------------------------------------------------

#ifndef __MACAPP__
#include <MacApp.h>
#endif

#ifndef __UPRINTING__
#include <UPrinting.h>
#endif

#ifndef __UGRIDVIEW__
#include <UGridView.h>
#endif

#ifndef __UTEVIEW__
#include <UTEView.h>
#endif

#ifndef __UDIALOG__
#include <UDialog.h>
#endif

#ifndef __UGEOMETRY__
#include <UGeometry.h>
#endif

#ifndef __UFLOATWINDOW__
#include <UFloatWindow.h>
#endif

#ifndef __UDEMO3D__
#include <UDemo3D.h>
#endif

#ifndef __U3DDRAWING__
#include "U3DDrawing.h"
#endif

//----------------------------------------------------------------------------------------
// main:
//----------------------------------------------------------------------------------------
#pragma push
#pragma processor 68000

void main()
{
	InitToolBox();

	if (ValidateConfiguration(gConfiguration))
	{
		InitUMacApp(12);							// Initialize MacApp; 12 calls to MoreMasters
		InitUTEView();
		InitUDialog();
		InitUGridView();
		InitUFloatWindow();
		InitU3DDrawing();							// Add 3-d drawing unit

		TTestApplication* gTestApplication = new TTestApplication;
		gTestApplication->ITestApplication();
		gTestApplication->Run();
	}
	else
		StdAlert(phUnsupportedConfiguration);
} // main

#pragma pop
