//----------------------------------------------------------------------------------------
//	File:		Demo3D.h
//
//	Contains:	3D drawing demo program
//
//	Written by:	Jamie Osborne
// 				Adapted for 3.1.1 by Jeroen Schalk
//
//	Copyright:	 1992-1994 by Apple Computer, Inc.
//----------------------------------------------------------------------------------------

#ifndef __UDEMO3D__
#define __UDEMO3D__

#ifndef __TYPES__
#include <Types.h>
#endif

#ifndef __MACAPPTYPES__
#include <MacAppTypes.h>
#endif

#ifndef __UEVENTHANDLER__
#include <UEventHandler.h>
#endif

#ifndef __UCCOMMANDHANDLER__
#include <UCommandHandler.h>
#endif

#ifndef __UAPPLICATION__
#include <UApplication.h>
#endif

#ifndef __UADORNERS__
#include <UAdorners.h>
#endif

#ifndef __UVIEW__
#include <UView.h>
#endif

#ifndef __UBEHAVIOR__
#include <UBehavior.h>
#endif

#ifndef __UMACAPPGLOBALS__
#include <UMacAppGlobals.h>
#endif

//  Building Blocks

#ifndef __UDIALOG__
#include <UDialog.h>
#endif

#ifndef __UGRIDVIEW__
#include <UGridView.h>
#endif

const OSType kSignature = 'DE3D';			// Application signature
const OSType kFileType = 'DE3D';			// File-type code used for document files

//----------------------------------------------------------------------------------------
// TTestApplication
//----------------------------------------------------------------------------------------
class TTestApplication : public TApplication
{
	DeclareClass(TTestApplication);

public:
	virtual void ITestApplication();
		// Initializes the application and globals.

	virtual TDocument* DoMakeDocument(CommandNumber itsCommandNumber,
									  TFile* itsFile);// override

	virtual void DoMenuCommand(CommandNumber aCommandNumber);// override
	virtual void DoSetupMenus();			// override

protected:									// the procedures to do the views by procedures!!
	virtual void	MakeDrawingWind();
	virtual void	MakeDrawingProcWind();
};

//----------------------------------------------------------------------------------------
// TDemoWindow
//----------------------------------------------------------------------------------------

class TDemoWindow : public TWindow
{
	DeclareClass(TDemoWindow);

public:
	virtual void DoEvent(EventNumber eventNumber,
									 TEventHandler* source,
									 TEvent* event);
};

#endif

