/**

	ShellSort
	
	An example plug in module for SuperSort application.
	
	The plug in mechanism for SuperSort guarantees us that
	
	 1993 Apple Computer, Inc.

	Written by Tim Nichols
	
	Change history:
	
	8/11/93		TCN		New today.
	
**/

#include "SortPlugIn.h"

#if powerc
#include <MixedMode.h>
ProcInfoType swapPI = kCStackBased 	| STACK_ROUTINE_PARAMETER(1,kFourByteCode) 
									| STACK_ROUTINE_PARAMETER(2,kFourByteCode);
#endif

void ShellSort(DataPoint *data,short size,SwapProc swap);

void ShellSort(DataPoint *data,short size,SwapProc swap)
{
	short i,j,incr;
	
	incr = size / 2;
	while(incr > 0)
	{
		for(i=incr;i<size;i++)
		{
			j = i - incr;
			while(j>=0)
			{
				if(data[j].n > data[j+incr].n)
				{
				#if powerc
					// must use CallUniversalProc since we will be passed a UPP for the SwapProc
					CallUniversalProc(swap,swapPI,&data[j],&data[j+incr]);
				#else
					// if we're 68k, we can just call the proc directly 
					//MixedMode will handle switching if swap is a UPP
					(*swap)(&data[j],&data[j+incr]);
				#endif
					j -= incr;
				}
				else
					j = -1;
			}
		}
		incr /= 2;
	}
}