/**	

	SuperSorts.h
	
	by Tim Nichols

	 1993 Apple Computer, Inc.

**/

#include <Quickdraw.h>
#include <Events.h>
#include <Windows.h>

/*
	menu constants
*/
#define mApple 		128
#define mFile		129
#define mEdit		130
#define mData		131
#define mAlgorithm	132

/*
	width and height of window
	(Yah, I know, I should compute this, but what the heck).
*/
#define kHeight		300
#define	kWidth		600

#define kSmall		50		// number of points in small data set
#define	kMedium		150		// number of points in medium data set
#define kLarge		300		// number of points in large data set

/*
	coordinates in window of rect where bars are drawn.
*/
#define kLeft	6
#define	kTop	6
#define	kRight	606
#define	kBottom	220

#define	kMin	5			// minimum height of a bar
#define	kMax	100			// maximum height of a bar

#define kBubble		1		// bubble sort is the first algorithm in menu
#define kQuick		2		// quick sort is the second algorithm in menu

struct DataPoint {			// each data point has a value and a corresponding rect
	short	 n;
	Rect	r;
};

typedef struct DataPoint DataPoint;

typedef void (*SwapProc)(DataPoint *a,DataPoint *b);
typedef void (*SortProc)(DataPoint *data,short nPoints,SwapProc swap);

/*
	prototypes
*/
void InitToolbox(void);

void InitData(void);
void NewData(void);
void DrawData(void);

void EventLoop(void);
void DoEvent(EventRecord *e);
void DoMouseDown(EventRecord *e);
void DoKeyDown(EventRecord *e);
void DoUpdate(WindowPtr w);

void MakeMenus(void);
void AdjustMenus(void);
void DoMenuCommand(long menuResult);
void HandleAppleMenu(short item);
void HandleFileMenu(short item);
void HandleDataMenu(short item);
void HandleAlgorithmMenu(short item);

void BailIf(Boolean b,Str255 s);
void AddPlugIns(void);

void GetSeed(void);

void DrawTime(void);
void DrawAlgorithm(void);

void Sort(short which);
void Swap(DataPoint *a,DataPoint *b);

void BubbleSort(DataPoint *data,short size,SwapProc swap);
void DoQuickSort(DataPoint *data,short size,SwapProc swap);
void QuickSort(DataPoint *data,short first,short last,SwapProc swap);
short FindPivot(DataPoint *data,short i,short j);
short Partition(DataPoint *data,short i,short j,short pivot,SwapProc swap);
