/*	Sort
**	
**	A simple PowerPC/68K app.  Shows off the speed of RISC vs. CISC
**
**	by Tim Nichols
**
**	 1993 Apple Computer, Inc.
**
**	This file contains useful timing stuff.
*/

#include "Timing.h"
#include <Timer.h>
#include <Memory.h>

static TMTaskPtr	gTimerTask = nil;
static long 		gDelay = 0;

long StartTimer(void)
{
	gTimerTask = (TMTaskPtr)NewPtrClear(sizeof(TMTask));
	InsTime((QElemPtr)gTimerTask);
	gDelay = kMaxTime;
	PrimeTime((QElemPtr)gTimerTask,gDelay);
	return 0;
}

long StopTimer(void)
{
	long ms = 0;
	
	RmvTime((QElemPtr)gTimerTask);
	ms = gDelay + gTimerTask->tmCount/1000;
	DisposePtr((Ptr)gTimerTask);
	return ms;
}
