/*
	File:		StdPrefsLib.r

	Contains:	Standard preferences library resources.

				Refer to develop Issue 18, "The Right Way to Implement 
				Preferences Files", for additional details on this code.
				
	Written by:	Gary Woodcock

	Copyright:	 1993-94 by Apple Computer, Inc.

	Change History (most recent first):
	
				  3/3/94	Version 1.0.
	
	Notes: 		This code uses Apple's Universal Interfaces for C.
	
				Send bug reports to Gary Woodcock at AOL: gwoodcock
				or Internet: gwoodcock@aol.com.
*/

#include "CompileFlags.h"

#define SystemSevenOrLater 1
#define SystemSevenOrBetter	1

#define forRez 1

#include "SysTypes.r"
#include "Types.r"

#include "StdPrefsLibPrivate.h"

resource 'STR#' (kStdPrefsLibStrsID) {
	{	/* array StringArray: 2 elements */
		/* [1] */
		"This document describes user preferences for ",
		/* [2] */
		". You cannot open or print this document. To be "
		"effective, this document must be stored in the "
		"Preferences folder in the System Folder."
	}
};

#undef forRez