/*
	File:		StdPrefsLibPrivate.h

	Contains:	Private header file for standard preferences library 
				routines.

				Refer to develop Issue 18, "The Right Way to Implement 
				Preferences Files", for additional details on this code.
				
	Written by:	Gary Woodcock

	Copyright:	 1993-94 by Apple Computer, Inc.

	Change History (most recent first):
	
				  3/3/94	Version 1.0.
	
	Notes: 		This code uses Apple's Universal Interfaces for C.
	
				Send bug reports to Gary Woodcock at AOL: gwoodcock
				or Internet: gwoodcock@aol.com.
*/

//-----------------------------------------------------------------------
// Includes

#ifndef	_STDPREFSLIBPRIVATE_
#define	_STDPREFSLIBPRIVATE_

#include "CompileFlags.h"

#ifndef forRez

#include "StdPrefsLib.h"

#endif forRez

//-----------------------------------------------------------------------
// Private constants

// Base resource ID
#define kStdPrefsLibBaseResID	400

#define	kStdPrefsLibStrsID		kStdPrefsLibBaseResID
#define kPreambleStrID			1
#define	kPostambleStrID			2

//-----------------------------------------------------------------------

#endif _STDPREFSLIBPRIVATE_

//-----------------------------------------------------------------------
