UNIT CTdebugStream;



INTERFACE

USES
	
	Types, Traps, Memory, Quickdraw, 
	OSIntf, ToolIntf, PackIntf;


PROCEDURE StreamToDebugger(textBuf: Ptr; count: INTEGER);

PROCEDURE Str255ToDebugger(msg: Str255);

PROCEDURE StrLineToDebugger(msg: Str255);



IMPLEMENTATION

USES
	
	PPCToolbox,
	
	Events, AppleEvents,
	
	IntEnv, 
	
	PasLibIntf,
	
	AEregistry;



PROCEDURE StreamToDebugger(textBuf: Ptr; count: INTEGER);
VAR
	theEvent,
	theReply:		AppleEvent;
	target:			AEAddressDesc;
	err:			OSerr;
	appSignature:	OStype;
BEGIN
	appSignature:= 'CTLD';	{ look for CTdebugger by signature }
	err:= AECreateDesc(typeApplSignature, @appSignature, 
						sizeof(appSignature), target);
	IF err = noErr THEN
		BEGIN
		err:= AECreateAppleEvent('CTLD', 'DEBG',
								 target, kAutoGenerateReturnID,
								 kAnyTransactionID, theEvent);
		IF err = noErr THEN
			BEGIN
			err:= AEPutParamPtr(theEvent, keyDirectObject, typeChar,
								textBuf, count);
			
			IF err = noErr THEN
				err:= AESend(theEvent, theReply, kAENoReply + kAECanInteract,
							 kAENormalPriority, 120, NIL, NIL);

			err:= AEDisposeDesc(theEvent);
			END;
		err:= AEDisposeDesc(target);
		END;
END;


PROCEDURE Str255ToDebugger(msg: Str255);
BEGIN
	IF msg <> '' THEN
		StreamToDebugger(Ptr(@msg[1]), length(msg));
END;


PROCEDURE StrLineToDebugger(msg: Str255);
VAR
	retStr:		String[2];
BEGIN
	retStr:= ' ';
	retStr[1]:= chr(13);
	
	Str255ToDebugger(msg);
	Str255ToDebugger(retStr);
END;


END.
 