/*------------------------------------------------------------------------------

	  Sample.r	-  Resources for the Sample Application

	  Copyright Apple Computer, Inc. 1985-1987

------------------------------------------------------------------------------*/

#include "Types.r"
#include "SysTypes.r"

/* These define's are used in the MENU resources to disable specific
   menu items. */
#define AllItems	0b1111111111111111111111111111111	/* 31 flags */
#define MenuItem1	0b00001
#define MenuItem2	0b00010
#define MenuItem3	0b00100
#define MenuItem4	0b01000
#define MenuItem5	0b10000

type 'desa' as 'STR ';

resource 'SIZE' (-1, purgeable) {
	saveScreen,
	acceptSuspendResumeEvents,
	disableOptionSwitch,
	canBackground,
	multiFinderAware,
	backgroundAndForeground,
	dontGetFrontClicks,
	ignoreChildDiedEvents,
	not32BitCompatible,
	isHighLevelEventAware,
	localAndRemoteHLEvents,
	notStationeryAware,
	dontUseTextEditServices,
	reserved,
	reserved,
	reserved,
	204800,
	153600
};

resource 'vers' (1) {
	0x01, 0x00, release, 0x00,
	verUs,
	"0.00",
	"0.00, Copyright  1989 Apple Computer, Inc."
};

resource 'desa' (0, purgeable) {
	"Sample Picture Reading App by Macintosh Developer Technical Support"
};

resource 'BNDL' (128, purgeable) {
	'desa',
	0,
	{
	'ICN#', {0, 128},
	'FREF', {0, 128}
	}
};

resource 'FREF' (128, purgeable) {
	'APPL',
	0,
	""
};



resource 'ICN#' (128, purgeable) {
	{	/* array: 2 elements */
		/* [1] */
		$"0000 0000 07FF FFE0 0800 0010 09FF FF90"
		$"0A00 0050 0A00 0050 0AF3 E750 0A88 8850"
		$"0A88 8850 0A88 8650 0A88 8150 0A88 8150"
		$"0AF0 8E50 0A00 0050 0A00 0050 0A00 0050"
		$"09FF FF90 0800 0010 0FFF FFF0 0800 0010"
		$"0800 0010 0800 0010 0800 7F10 0800 0010"
		$"0800 0010 0800 0010 0800 0010 07FF FFE0"
		$"0400 0020 0400 0020 0400 0020 07FF FFE0",
		/* [2] */
		$"0000 0000 07FF FFE0 0FFF FFF0 0FFF FFF0"
		$"0FFF FFF0 0FFF FFF0 0FFF FFF0 0FFF FFF0"
		$"0FFF FFF0 0FFF FFF0 0FFF FFF0 0FFF FFF0"
		$"0FFF FFF0 0FFF FFF0 0FFF FFF0 0FFF FFF0"
		$"0FFF FFF0 0FFF FFF0 0FFF FFF0 0FFF FFF0"
		$"0FFF FFF0 0FFF FFF0 0FFF FFF0 0FFF FFF0"
		$"0FFF FFF0 0FFF FFF0 0FFF FFF0 07FF FFE0"
		$"07FF FFE0 07FF FFE0 07FF FFE0 07FF FFE0"
	}
};


resource 'WIND' (128, "Sample Window") {
	{40, 0, 280, 320},
	documentProc, invisible, noGoAway, 0x0, "Sample Window"
};

resource 'DLOG' (128, "About Sample") {
	{66, 102, 224, 400},
	dBoxProc, visible, noGoAway, 0x0, 128, ""
};

resource 'DITL' (128) {
	 {
/* 1 */ {130, 205, 150, 284},
		button {
			enabled,
			"Continue"
		};
/* 2 */ {104, 144, 120, 296},				/* SourceLanguage Item */
		staticText {
			disabled,
			""
		};
/* 3 */ {88, 144, 105, 218},				/* Author Item */
		staticText {
			disabled,
			""
		};
/* 4 */ {8, 32, 26, 273},
		staticText {
			disabled,
			"Macintosh Programmer's Workshop"
		};
/* 5 */ {32, 50, 50, 392},
		staticText {
			disabled,
			"Sample PICT massaging Application"
		};
/* 6 */ {56, 16, 74, 281},
		staticText {
			enabled, "Copyright  1985-1993 Apple Computer"
		};
/* 7 */ {88, 16, 104, 144},
		staticText {
			enabled, "Source Language:"
		};
/* 8 */ {104, 16, 120, 144},
		staticText {
			enabled, "Brought to you by:"
		}
	}
};

resource 'MENU' (128, "Apple", preload) {
	128, textMenuProc,
	AllItems & ~MenuItem2,	/* Disable item #2 */
	enabled, apple,
	{
		"About Sample",
			noicon, nokey, nomark, plain;
		"-",
			noicon, nokey, nomark, plain
	}
};

resource 'MENU' (129, "File", preload) {
	129, textMenuProc,
	allEnabled,
	enabled, "File",
	{
		"Print",
			noicon, "P", nomark, plain;
		"Page Setup...",
			noicon, nokey, nomark, plain;
		"Quit",
			noicon, "Q", nomark, plain
	}
};

resource 'MENU' (130, "Edit", preload) {
	130, textMenuProc,
	AllItems & ~(MenuItem1 | MenuItem2),	/* Disable items #1 & #2 */
	enabled, "Edit",
	 {
		"Undo",
			noicon, "Z", nomark, plain;
		"-",
			noicon, nokey, nomark, plain;
		"Cut",
			noicon, "X", nomark, plain;
		"Copy",
			noicon, "C", nomark, plain;
		"Paste",
			noicon, "V", nomark, plain;
		"Clear",
			noicon, nokey, nomark, plain
	}
};

resource 'MENU' (131, "Display PICT", preload) {
	131, textMenuProc,
	allEnabled,
	enabled, "Display PICT",
	{
		"Original",
			noicon, "D", nomark, plain;
		"Modified No CLUT",
			noicon, "N", nomark, plain;
		"Modified Add CLUT",
			noicon, "X", nomark, plain;
	}
};


resource 'DITL' (129, purgeable) {
	{	/* array DITLarray: 2 elements */
		/* [1] */
		{78, 173, 98, 243},
		Button {
			enabled,
			"Away!"
		},
		/* [2] */
		{31, 74, 68, 257},
		StaticText {
			disabled,
			"This program can only print PICTs that f"
			"it in memory"
		}
	}
};

resource 'ALRT' (129, purgeable) {
	{50, 30, 165, 290},
	129,
	{	/* array: 4 elements */
		/* [1] */
		OK, visible, sound3,
		/* [2] */
		OK, visible, sound1,
		/* [3] */
		OK, visible, sound2,
		/* [4] */
		OK, visible, sound3
	}
};

