language:  infix-dylan
module:    studio
author:    Steve Strassmann, straz@apple.com
copyright: This code is in the public domain
version:   1.0b1 20-Nov-94
comment:   code to accompany an article in Develop magazine, Feb-95
title:     Listing 2 -- SimMogul  embellished version


define class <project> (<object>)
	slot script;		       					// All you need is a hot script
	slot star;					        			//  and a big name.
end class <project>;					 	// Last two words are optional.

define class <actor> (<object>)
	slot name :: <string>, 				// Actor's name
		required-init-keyword: name:;
	slot salary :: <number>,			// Cost to hire
		init-value: 1000000,
		init-keyword: salary:;
	slot fans :: <number>, 				// Audience size
		init-value: 1000000,
		init-keyword: fans:;
end class;

define class <script> (<object>)
	slot name :: <string>,			   	// Script's name
		required-init-keyword: name:; 
	slot fx-budget :: <number>,		// Cost of special effects
		init-value: 10000,
		init-keyword: fx-budget:;
end class;

define class <sci-fi> (<script>)
	inherited slot fx-budget, init-value: 20000000;
end class;

define class <romance> (<script>)
	inherited slot fx-budget, init-value: 0;
end class;

define variable arnold = 
	make(<actor>, name: "Arnold", fans: 10000000);

define variable betty = 
	make(<actor>, name: "Betty", fans: 5000000);

define variable tender :: <script> = 
	make(<romance>, name: "Tender Sunshine");

define variable zarx :: <script> = 
	make(<sci-fi>, name: "Land of the Zarx-Eaters");

define constant $ticket-price = 7;
