language:  infix-dylan
module:    studio
author:    Steve Strassmann, straz@apple.com
copyright: This code is in the public domain
version:   1.0b1 20-Nov-94
comment:   code to accompany an article in Develop magazine, Feb-95
title:     Listing 4 -- Example of return declarations and multiple return values

define class <brick>
	slot vert;
	slot horiz;
	slot depth;
	slot density;
end class;

define method calculate-weight (b :: <brick>)
	=> weight :: <number>;						// Declare return parameter
	let (x, y, z) = bounding-box(b);			// Bind multiple values
	x * y * z * b.density;						// Return one value
end method;

define method bounding-box (b :: <brick>)
	=> (height :: <number>, width :: <number>, length :: <number>);
	values(b.vert, b.horiz, b.depth);			// Return three values
end method;
